; 360x480 and 320x 400 set mode, & pixel funtions 
; taken and modifyed from the articles in 
; the Programers Journal by Mitchael Abrash.

; Line drawing funtions taken from the book 
; Programers guide to PC & PS/2 video systems by Richard Wilton.
; and modifyed to work in 360x480 and 320x400.  

; demo c programs 386col.c,386spin.c,polyspin.c by Saul Scudder
; see 386col.c for examples of how call this.
; Any errors are mine. --- Saul Scudder

; c assembler interface funtions to:
;  Set 256 color 360x480 mode in c 
;  Set 1 pix in 360x480 mode
;  Read 1 pix in 360x480 mode
;  Draw any line in 360x480 mode
;  show rom thext in 360x480
;  Also same for 320x400

VGA_SEGMENT     EQU     0a000h
SC_INDEX        EQU     03C4h
GC_INDEX        EQU     03ceh

CRTC_INDEX      EQU     03D4h
MAP_MASK        EQU     2
READ_MAP        EQU     4
WORD_OUTS_OK    EQU     1

MAX_SCAN_LINE   EQU     9
START_ADDRESS_HIGH      EQU  0ch
UNDERLINE       EQU     14h
MODE_CONTROL    EQU     17h
MEMORY_MODE     EQU     4
GRAPHICS_MODE   EQU     5
MISCELLANEOUS   EQU     6

SCREEN_WIDA    EQU     360
SCREEN_HA   EQU     480
SCREEN_WIDB    EQU     320
SCREEN_HB   EQU     400

; for pixel ops;

XPIX            EQU    WORD PTR [bp+6]
YPIX            EQU    WORD PTR [bp+8]
PCOL            EQU    BYTE PTR [bp+10]

; for line drawing

ARGX1           EQU    WORD PTR [bp+6]
ARGY1           EQU    WORD PTR [bp+8]
ARGX2           EQU    WORD PTR [bp+10]
ARGY2           EQU    WORD PTR [bp+12]
ARGN            EQU    BYTE PTR [bp+14]
VARINCR1        EQU    WORD PTR [bp-6]
VARINCR2        EQU    WORD PTR [bp-8]
VARROUTINE      EQU    WORD PTR [bp-10]
BPLA    EQU    90
BPLB    EQU    80

; for char display

ARGC             EQU    WORD PTR [bp+6]
ARGX             EQU    WORD PTR [bp+8]
ARGY             EQU    WORD PTR [bp+10]
ARGFGD           EQU    BYTE PTR [bp+12]
ARGBGD           EQU    BYTE PTR [bp+14]

.MODEL large

OUT_WORD        macro
if WORD_OUTS_OK
        out     dx,ax
else
        out     dx,al
        inc     dx
        xchg    ah,al
        out     dx,al
        dec     dx
        xchg    ah,al
endif
        endm

CONSTANT_TO_INDEXED_REGISTER    macro   ADDRESS, INDEX, VALUE
        mov     dx,ADDRESS
        mov     ax,(VALUE shl 8) + INDEX
        OUT_WORD
        endm

.DATA
vptbl   dw 06b00h
        dw 05901h
        dw 05a02h
        dw 08e03h
        dw 05e04h
        dw 08a05h
        dw 00d06h
        dw 03e07h
        dw 04009h
        dw 0ea10h
        dw 0ac11h
        dw 0df12h
        dw 02d13h
        dw 00014h
        dw 0e715h
        dw 00616h
        dw 0e317h
vpend label word

sx      dw  ?
sy      dw  ?

.CODE

; extern void s360x480(void);


        PUBLIC   _s360x480
_s360x480  PROC    

        
        push  bp
        mov   bp, sp
        push  si
        push  di

        mov     ax,0012h
        int     10h

        mov     ax,0013h
        int     10h

        mov     dx,SC_INDEX
        mov     ax,0604h
        out     dx,ax

        mov     ax,0100h
        out     dx,ax

        mov     dx,3c2h
        mov     al,0e7h
        out     dx,al

        mov     dx,SC_INDEX
        mov     ax,300h
        out     dx,ax

        mov     dx,CRTC_INDEX
        mov     al,11h
        out     dx,al

        inc     dx

        in      al,dx
        and     al,7fh
        out     dx,al

        dec     dx
        cld

        mov     si, offset vptbl
        mov     cx,((offset vpend)-(offset vptbl)) shr 1
NP:     lodsw
        out     dx,ax
        loop    NP
        pop     di
        pop     si
        pop     bp
        ret
_s360x480 ENDP

; extern void s320x400(void);

        PUBLIC   _S320x400
_s320x400  PROC    

        push  bp
        mov   bp, sp

        mov     ax,0013h
        int     10h

        mov     dx,SC_INDEX
        mov     al,MEMORY_MODE
        out     dx,al
        inc     dx
        in      al,dx
        and     al,not  08h
        or      al,04h
        out     dx,al
        mov     dx,GC_INDEX
        mov     al,GRAPHICS_MODE
        out     dx,al
        inc     dx
        in      al,dx
        and     al,not 10h
        out     dx,al
        dec     dx
        mov     al,MISCELLANEOUS
        out     dx,al
        inc     dx
        in      al,dx
        and     al,not 02h
        out     dx,al

        CONSTANT_TO_INDEXED_REGISTER SC_INDEX,MAP_MASK,0fh

        mov     ax,VGA_SEGMENT
        mov     es,ax
        sub     di,di
        mov     ax,di
        mov     cx,8000h
        cld
        rep     stosw

        mov     dx,CRTC_INDEX
        mov     al,MAX_SCAN_LINE
        out     dx,al
        inc     dx
        in      al,dx
        and     al,not  1fh
        out     dx,al
        dec     dx

        mov     al,UNDERLINE
        out     dx,al
        inc     dx
        in      al,dx
        and     al,not 40h
        out     dx,al
        dec     dx
        mov     al,MODE_CONTROL
        out     dx,al
        inc     dx
        in      al,dx
        or      al,40h

        out     dx,al
        pop bp
        ret

_s320x400 ENDP


      PUBLIC _writep16
_writep16         PROC    
        push  bp
        mov   bp, sp
        push  si
        push  di

        mov   cx, XPIX           ; x
        mov   dx, YPIX           ; y
        mov   bl, PCOL           ; col

        mov     ax,VGA_SEGMENT
        mov     es,ax
        mov     ax,SCREEN_WIDA/4
        mul     dx                 ; * y

        push    cx                 ; x
        shr     cx,1
        shr     cx,1
        add     ax,cx
        mov     di,ax

        pop     cx
        and     cl,3
        mov     ah,1
        shl     ah,cl
        mov     al,MAP_MASK
        mov     dx,SC_INDEX
        OUT_WORD
        mov     es:[di],bl

        pop  di
        pop  si
        mov  sp, bp
        pop bp
        ret

_writep16      ENDP

        PUBLIC _writep15
_writep15         PROC    
        push  bp
        mov   bp, sp
        push  si
        push  di

        mov   cx, XPIX           ; x
        mov   dx, YPIX           ; y
        mov   bl, PCOL           ; col

        mov     ax,VGA_SEGMENT
        mov     es,ax
        mov     ax,SCREEN_WIDB/4
        mul     dx
        push    cx
        shr     cx,1
        shr     cx,1
        add     ax,cx
        mov     di,ax
        pop     cx
        and     cl,3
        mov     ah,1
        shl     ah,cl
        mov     al,MAP_MASK
        mov     dx,SC_INDEX
        OUT_WORD
        mov     es:[di],bl

        pop  di
        pop  si
        mov   sp, bp
        pop bp
        ret

_writep15      ENDP


      PUBLIC _readp16
_readp16  PROC    
        push  bp
        mov   bp, sp
        push  si
        push  di

        mov     ax,VGA_SEGMENT
        mov     es,ax
        mov     ax,SCREEN_WIDA/4
        mov     dx, YPIX         ; y
        mul     dx

        mov     bx, XPIX
        shr     bx, 1
        shr     bx, 1
        add     bx, ax
        mov     si, bx

        mov     ax, XPIX
        and     ax,3
        mov     ah,al
        mov     al,READ_MAP
        mov     dx,GC_INDEX
        OUT_WORD

        lods    BYTE PTR es:[si]
        sub     ah, ah

        pop  di
        pop  si
        mov  sp, bp
        pop bp
        ret
_readp16       ENDP

      PUBLIC _readp15
_readp15  PROC    
        push  bp
        mov   bp, sp
        push  si
        push  di

        mov     ax,VGA_SEGMENT
        mov     es,ax
        mov     ax,SCREEN_WIDB/4
        mov     dx, YPIX         ; y
        mul     dx

        mov     si, XPIX
        shr     si,1
        shr     si,1
        add     si,ax

        mov     ax, XPIX
        and     al,3
        mov     ah,al
        mov     al,READ_MAP
        mov     dx,GC_INDEX
        OUT_WORD
        lods    BYTE PTR es:[si]
        mov     ah, 0

        pop  di
        pop  si
        mov  sp, bp
        pop bp
        ret
_readp15       ENDP

; below gets    ax = y bx = x
; below returns bx:es & dx as x
; uses dx,bx,ax

PixelAddr16 PROC    ; vga 256 360x480

         mov  dx,ax               ; y
         mov  ax,VGA_SEGMENT      ;
         mov  es,ax               ; seg in
         mov  ax,BPLA     ; get y offset
         mul  dx                  ; y * 90
         mov  dx,bx               ; save x
         mov  bx,ax               ; bx so ret
         ret

PixelAddr16 ENDP 

; below gets    ax = y bx = x
; below returns bx:es & dx as x
; uses dx,bx,ax

PixelAddr15 PROC    ; vga 256 320x400

         mov  dx,ax               ; y
         mov  ax,VGA_SEGMENT      ;
         mov  es,ax               ; seg in
         mov  ax,BPLB     ; get y offset
         mul  dx                  ; y * 80
         mov  dx,bx               ; save x
         mov  bx,ax               ; bx so ret
         ret

PixelAddr15 ENDP 

; in al = color, bx = yinc, cx = num, si = decision
; dx/4 is point, dx and 3 is table 

Drawit16 PROC
         push cx
         push bx
         push ax
         push dx        ; save x

         mov  cx, dx    ; copy coord
         and  cl,3      
         mov  ah,1      
         shl  ah,cl     
         mov  al,MAP_MASK
         mov  dx,SC_INDEX
         OUT_WORD

         pop dx      ; get back x
         mov cx,dx   ; x to cx
         shr cx,1
         shr cx,1    ; x/4
         mov bx,di   ; y * 90
         add cx,bx   ; x/4 + y*90
         mov di,cx   ; point to
         pop ax           ; get color
         mov es:[di],al   ; move it out
         mov di,bx        ; put y*90 back
         inc dx           ; increase x
         pop bx
         pop cx
         ret
Drawit16 ENDP

; in al = color, bx = yinc,cx = num,si = decision
; dx/4 is point, dx and 3 is table 

Drawit15 PROC
         push cx
         push bx
         push ax
         push dx        ; save x

         mov  cx, dx    ; copy coord
         and  cl,3      
         mov  ah,1      
         shl  ah,cl     
         mov  al,MAP_MASK
         mov  dx,SC_INDEX
         OUT_WORD

         pop dx      ; get back x
         mov cx,dx   ; x to cx
         shr cx,1
         shr cx,1    ; x/4
         mov bx,di   ; y * 80
         add cx,bx   ; x/4 + y*80
         mov di,cx   ; point to
         pop ax           ; get color
         mov es:[di],al   ; move it out
         mov di,bx        ; put y*80 back
         inc dx           ; increase x
         pop bx
         pop cx
         ret
Drawit15 ENDP

; 'c' call with int xa,ya,xb,yb,color;
; line16(int xa, int ya, int xb, int yb,int color);

     PUBLIC _line16
_line16    PROC
        push  bp
        mov   bp, sp
        sub   sp,6
        push  si
        push  di

        mov si,BPLA
        mov cx,ARGX2
        sub cx,ARGX1
        jz VertLine16

        jns L01

        neg cx

        mov  bx,ARGX2
        xchg bx,ARGX1
        mov  ARGX2,bx

        mov bx,ARGY2
        xchg bx,ARGY1
        mov  ARGY2,bx

L01:    mov bx,ARGY2
        sub bx,ARGY1

        jz HorizLine16

        jns L03

        neg bx
        neg si

L03:    push si          ; 

        mov VARROUTINE, offset LoSlopeLine16
        cmp bx,cx
        jle L04

        mov VARROUTINE, offset HiSlopeLine16
        xchg bx,cx

L04:    shl bx,1
        mov VARINCR1,bx
        sub bx,cx
        mov si,bx

        sub bx,cx
        mov VARINCR2,bx

        push cx
        mov ax,ARGY1
        mov bx,ARGX1

        call PixelAddr16

        mov di,bx
        pop cx
        inc cx

        pop bx
        jmp VARROUTINE

VertLine16:

         mov ax,ARGY1
         mov bx,ARGY2      
         mov cx,bx
         sub cx,ax        ; cx = dy
         jge L31

         neg cx
         mov ax,bx

L31:     inc cx
         mov bx,ARGX1
         push cx
         call PixelAddr16
         pop cx

         mov di,bx

         mov al,ARGN

L32:     call Drawit16
         add di,si
         dec dx
         loop L32

         jmp Lexit

HorizLine16:
         push cx
         mov ax,ARGY1
         mov bx,ARGX1
         call PixelAddr16
         mov di,bx
         pop cx
         inc cx
         mov al,ARGN

x1:      call Drawit16
         loop x1

         jmp Lexit

LoSlopeLine16:

         mov al,ARGN

L11:     call Drawit16

         or si,si
         jns L12

         add si,VARINCR1
         loop L11
         jmp Lexit

L12:     add si,VARINCR2
         add di,bx        ; increment y
         loop L11
         jmp Lexit

HiSlopeLine16:
         mov al,ARGN

L21:     call Drawit16

         add di,bx

L22:     or si,si
         jns L23

         add si,VARINCR1
         dec dx             ; dec x

         loop L21

         jmp Lexit

L23:     add si,VARINCR2
         loop L21

Lexit:   pop di
         pop si
         mov sp,bp
         pop bp
         ret

_line16 ENDP


; extern line15(x1,y1,x2,y2,color);


     PUBLIC _line15
_line15    PROC
        push  bp
        mov   bp, sp
        sub   sp,6
        push  si
        push  di

        mov si,BPLB
        mov cx,ARGX2
        sub cx,ARGX1
        jz VertLine15

        jns LL01

        neg cx

        mov  bx,ARGX2
        xchg bx,ARGX1
        mov  ARGX2,bx

        mov bx,ARGY2
        xchg bx,ARGY1
        mov  ARGY2,bx

LL01:    mov bx,ARGY2
        sub bx,ARGY1

        jz HorizLine15

        jns LL03

        neg bx
        neg si

LL03:    push si          ; 

        mov VARROUTINE, offset LoSlopeLine15
        cmp bx,cx
        jle LL04

        mov VARROUTINE, offset HiSlopeLine15
        xchg bx,cx

LL04:    shl bx,1
        mov VARINCR1,bx
        sub bx,cx
        mov si,bx

        sub bx,cx
        mov VARINCR2,bx

        push cx
        mov ax,ARGY1
        mov bx,ARGX1

        call PixelAddr15

        mov di,bx
        pop cx
        inc cx

        pop bx
        jmp VARROUTINE

VertLine15:

         mov ax,ARGY1
         mov bx,ARGY2      
         mov cx,bx
         sub cx,ax        ; cx = dy
         jge LL31

         neg cx
         mov ax,bx

LL31:     inc cx
         mov bx,ARGX1
         push cx
         call PixelAddr15
         pop cx

         mov di,bx

         mov al,ARGN

LL32:     call Drawit15
         add di,si
         dec dx
         loop LL32

         jmp LLexit

HorizLine15:
         push cx
         mov ax,ARGY1
         mov bx,ARGX1
         call PixelAddr15
         mov di,bx
         pop cx
         inc cx
         mov al,ARGN

XX1:     call Drawit15
         loop XX1

         jmp LLexit

LoSlopeLine15:

         mov al,ARGN

LL11:     call Drawit15

         or si,si
         jns LL12

         add si,VARINCR1
         loop LL11
         jmp LLexit

LL12:     add si,VARINCR2
         add di,bx        ; increment y
         loop LL11
         jmp LLexit

HiSlopeLine15:
         mov al,ARGN

LL21:     call Drawit15

         add di,bx

LL22:     or si,si
         jns LL23

         add si,VARINCR1
         dec dx             ; dec x

         loop LL21

         jmp LLexit

LL23:     add si,VARINCR2
         loop LL21

LLexit:   pop di
         pop si
         mov sp,bp
         pop bp
         ret

_line15 ENDP


     PUBLIC _dischar16

_dischar16    PROC
        push  bp
        mov   bp, sp
        push di
        push si
        push ds

        mov ax, ARGY
        mov bx, ARGX
        call PixelAddr16
        mov di, bx        ; y * 90

        mov ax, 40h
        mov ds, ax
        mov cx, ds:[85h]
        
        xor ax, ax
        mov ds, ax

        mov ax, ARGC
        mov bx, 43H*4
        lds si,ds:[bx]
        mul cl

        add si, ax

        mov bl, ARGFGD
        mov bh, ARGBGD

LK1:    push cx
        mov cx, 8
        lodsb
        mov ah, al

LK2:    mov al, bl
        shl ah, 1
        jc  LK3

        mov al, bh

LK3:    call Drawit16 
        loop LK2

        add di, BPLA
        sub dx, 8

        pop cx
        loop LK1

        pop ds
        pop si
        pop di
        mov sp, bp
        pop bp
        ret
_dischar16 ENDP

     PUBLIC _dischar15

_dischar15    PROC
        push  bp
        mov   bp, sp
        push di
        push si
        push ds

        mov ax, ARGY
        mov bx, ARGX
        call PixelAddr15
        mov di, bx         ; y * 80

        mov ax, 40h
        mov ds, ax
        mov cx, ds:[85h]
        
        xor ax, ax
        mov ds, ax

        mov ax, ARGC
        mov bx, 43H*4
        lds si,ds:[bx]
        mul cl

        add si, ax

        mov bl, ARGFGD
        mov bh, ARGBGD

HK1:    push cx
        mov cx, 8
        lodsb
        mov ah, al

HK2:    mov al, bl
        shl ah, 1
        jc  HK3

        mov al, bh

HK3:    call Drawit15 
        loop HK2

        add di, BPLB
        sub dx, 8

        pop cx
        loop HK1

        pop ds
        pop si
        pop di
        mov sp, bp
        pop bp
        ret
_dischar15 ENDP


      PUBLIC _xorp16
_xorp16         PROC    
        push  bp
        mov   bp, sp
        push  si
        push  di

        mov     ax,VGA_SEGMENT
        mov     es,ax
        mov     ax,SCREEN_WIDA/4
        mov     dx, YPIX         ; y
        mul     dx

        mov     bx, XPIX
        shr     bx, 1
        shr     bx, 1
        add     bx, ax
        mov     si, bx

        mov     ax, XPIX
        and     ax,3
        mov     ah,al
        mov     al,READ_MAP
        mov     dx,GC_INDEX
        push    ax
        OUT_WORD

        lods    BYTE PTR es:[si]
        xor     al, PCOL
        mov     dx,SC_INDEX
        mov     di, bx
        mov     bl, al
        pop     ax
        mov     al,MAP_MASK
        OUT_WORD
        mov     es:[di],bl

        pop  di
        pop  si
        mov  sp, bp
        pop bp
        ret
_xorp16      ENDP



; draw block address pixels

;      PUBLIC _drawbloc16
; _drawbloc         PROC    
;         push  bp
;         mov   bp, sp
; 
;         mov   ax,                    get seg and offset
;         mov   ax,
;                                      make sx and sy
;
;
; 
;         mov  sp, bp
;         pop bp
;         ret
; _drawbloc ENDP

            END
